using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ConfCenter
{
   public partial class FakeLoad: Form
   {
      private int sleepAmount;

      public void DetectInstallation ()
      {
         object tempPath = Microsoft.Win32.Registry.GetValue ("HKEY_CURRENT_USER\\Software\\Bots-United\\YaPB", "InstallPath", null);

         if (tempPath == null && MessageBox.Show (this, Main.Localizer.T ("YaPB Installation not found in registry. Do you want to show directory youself ?"), Main.Localizer.T (Main.CAPTION), MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
         {
            BrowseForBot.Description = Main.Localizer.T ("Select root YaPB Path.");

            if (BrowseForBot.ShowDialog (this) == DialogResult.OK && File.Exists (BrowseForBot.SelectedPath + "\\dlls\\yapb.dll"))
               Main.botPath = BrowseForBot.SelectedPath;
            else
            {
               MessageBox.Show (this, Main.Localizer.T ("You're selected wrong directory. Application Terminates."), Main.Localizer.T (Main.CAPTION), MessageBoxButtons.OK, MessageBoxIcon.Error);
               Application.Exit ();
            }
            System.Diagnostics.FileVersionInfo inf = System.Diagnostics.FileVersionInfo.GetVersionInfo (Main.botPath + "\\dlls\\yapb.dll");

            Microsoft.Win32.Registry.SetValue ("HKEY_CURRENT_USER\\Software\\Bots-United\\YaPB", "InstallPath", Main.botPath);
            Microsoft.Win32.Registry.SetValue ("HKEY_CURRENT_USER\\Software\\Bots-United\\YaPB", "CurrVersion", inf.FileVersion);

            string gameDir = "cstrike";

            if (Main.botPath.Contains ("czero"))
               gameDir = "czero";

            Microsoft.Win32.Registry.SetValue ("HKEY_CURRENT_USER\\Software\\Bots-United\\YaPB", "CS-Identify", gameDir);
         }

         if (Main.botPath == null)
            Main.botPath = tempPath.ToString ();

         Main.configPath = Main.botPath + "\\config\\";
      }
      
      public FakeLoad ()
      {
         InitializeComponent ();

         if (LangCode.Text == "ru")
            Main.Localizer.localOK = true;

         new Main.Localizer ();

         DetectInstallation ();
         
         Ticker.Start ();
         sleepAmount = 2;
      }

      private void TickIt (object sender, EventArgs e)
      {
         Ticker.Stop ();
         for (int i = 0; i < 100 && FakeBar.Value < 100; i++)
         {
            FakeBar.Value += 1;

            if (sleepAmount > 1)
               UnmanagedUtils.Sleep (Convert.ToUInt32 (sleepAmount)*10);
         }
         Close ();
      }

      public string Desc
      {
         set
         {
            FakeDesc.Text = value;
         }
      }

      public int SleepAmount
      {
         set
         {
            sleepAmount = value;
         }
      }
   }
}