//
// Copyright (c) 2007-2008, by YaPB Development Team. All rights reserved.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
// Version: $Id:$
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <time.h>

#pragma warning (disable : 4996)

unsigned short GenerateBuildNumber (void)
{
   // this function generates build number from the compiler date macros

   static char date[32];

   time_t dt = time (NULL);
   tm *the = localtime (&dt);

   strftime (&date[0], 31, "%b %d %Y", the);

   const char *months[12] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
   unsigned char monthDays[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

   int day = 0, year = 0, i = 0;

   for (i = 0; i < 11; i++)
   {
      if (strncmp (&date[0], months[i], 3) == 0)
         break;

      day += monthDays[i];
   }
   day += atoi (&date[4]) - 1;
   year = atoi (&date[7]) - 2000;

   unsigned short buildNumber = day + (int) ((year - 1) * 365.25);

   if ((year % 4) == 0 && i > 1)
      buildNumber += 1;

   return buildNumber - 1114;
}

void main (int argc, char *argv[])
{
   if (argc < 2)
   {
      printf ("Wrong number of parameters.\n");
      exit (1);
   }

   FILE *fp = fopen (argv[1], "rt");
   char line[256], lineBuffer[4048];

   memset (&line, 0, sizeof (char) * 256);
   memset (&lineBuffer, 0, sizeof (char) * 4048);

   unsigned int number = GenerateBuildNumber ();
 
   while (fgets (line, 255, fp) != NULL)
   {
      if (strncmp (line, "#define PRODUCT_BUILD_TOOL", 26) == 0)
         sprintf (line, "#define PRODUCT_BUILD_TOOL %u\n", number);

      if (lineBuffer[0] == 0)
         strcpy (lineBuffer, line);
      else
         strcat (lineBuffer, line);
   }
   fclose (fp);

   fp = fopen (argv[1], "wt");
   fprintf (fp, lineBuffer);
   fclose (fp);
}